commit a5b55378c95c29cac707fd3be2d2edc82ac7ec2d
Author: Iain Buclaw <ibuclaw@gdcproject.org>
Date:   Thu Jan 29 18:07:57 2026

    d: Fix infinite loop in dump_generic_node [PR123264]
    
            PR d/123264
    
    gcc/d/ChangeLog:
    
            * types.cc (finish_aggregate_type): Propagate struct TYPE_NAME to all
            TYPE_NEXT_VARIANT types.
    
    gcc/testsuite/ChangeLog:
    
            * gdc.dg/pr123264.d: New test.
    
    (cherry picked from commit 94d887ec2bab35e6eb17f68848a917689526c4e0)

diff --git a/gcc/d/types.cc b/gcc/d/types.cc
index 0b8583842ea..456ba6147ab 100644
--- a/gcc/d/types.cc
+++ b/gcc/d/types.cc
@@ -707,6 +707,7 @@ finish_aggregate_type (unsigned structsize, unsigned alignsize, tree type)
       if (t == type)
 	continue;
 
+      TYPE_NAME (t) = TYPE_NAME (type);
       TYPE_FIELDS (t) = TYPE_FIELDS (type);
       TYPE_LANG_SPECIFIC (t) = TYPE_LANG_SPECIFIC (type);
       TYPE_SIZE (t) = TYPE_SIZE (type);
diff --git a/gcc/testsuite/gdc.dg/pr123264.d b/gcc/testsuite/gdc.dg/pr123264.d
new file mode 100644
index 00000000000..a786c054e74
--- /dev/null
+++ b/gcc/testsuite/gdc.dg/pr123264.d
@@ -0,0 +1,8 @@
+// { dg-do compile }
+// { dg-options "-fdump-tree-original" }
+struct S123264
+{
+    void infinite(const S123264) { }
+    auto fn = &infinite;
+}
+// { dg-final { scan-tree-dump "const struct S123264" "original" } }

